<template>
  <div class="divider-y bg-1 bk8-custom h-screen unset-height">
    <div class="space-y-4 p-5" :class="{ '!px-2': themeName === 'playful' }">
      <h4 class="bk8-title">{{ $t("login_password") }}</h4>
      <div class="space-x-2 password-info flex flex-col">
        <div class="password-form">
          <el-form
            ref="ruleLoginPasswordFormRef"
            label-position="top"
            :model="loginPasswordFormData"
            status-icon
            :rules="loginPasswordRules"
            :validate-on-rule-change="false"
          >
            <el-form-item
              :label="$t('current_password')"
              prop="currentPassword"
            >
              <el-input
                v-model="loginPasswordFormData.currentPassword"
                type="password"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('current_password') : ''"
              />
            </el-form-item>
            <el-form-item :label="$t('new_password')" prop="newPassword">
              <el-input
                v-model="loginPasswordFormData.newPassword"
                type="password"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('new_password') : ''"
              />
            </el-form-item>
            <el-form-item
              :label="$t('confirm_password')"
              prop="confirmPassword"
            >
              <el-input
                v-model="loginPasswordFormData.confirmPassword"
                type="password"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('confirm_password') : ''"
              />
            </el-form-item>
            <el-form-item>
              <el-button
                :disabled="isLoginPassProccessing"
                type="primary"
                round
                @click="changeLoginPassword(ruleLoginPasswordFormRef)"
              >
                {{ $t("submit") }}
              </el-button
              >
            </el-form-item>
          </el-form>
        </div>
        <div class="password-remark">
          <b>
            <ul class="bg-1 space-y-2 text-sm rounded bk8-pwd">
              <h5
                :class="
                  theme == 'bk8'
                    ? 'secondary font-[400]'
                    : 'secondary font-bold'
                "
              >
                {{ $t("SBOKH_password_policy") }}
              </h5>
              <li>
                -
                {{
                  $t(
                    "password_must_contain_8_or_more_characters_with_a_mix_of_letters_number_and_symbols"
                  )
                }}
              </li>
              <li>
                - {{ $t("new_password_must_not_be_the_same_as_old_password") }}
              </li>
              <li>
                - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
              </li>
            </ul>
          </b>
        </div>
      </div>
    </div>
    <div v-if="isPaymentPasswordSet && isCashPlayer" class="space-y-4 p-5" :class="{ '!px-2': themeName === 'playful' }">
      <h4>{{ $t("payment_password") }}</h4>
      <div v-if="theme == 'bk8'" class="bk8-custom-bottom">
        <b>
          <ul class="space-y-2 text-sm rounded font-[400]">
            <h5 class="font-[400] bk8-policy">
              {{ $t("SBOKH_password_policy") }}
            </h5>
            <li>
              -
              {{
                $t(
                  "payment_password_will_use_to_verify_your_identity_for_any_fund_related_operation_for_account_safety_purposes_please_enter_4_digits"
                )
              }}
            </li>
            <li>
              - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
            </li>
          </ul>
        </b>
      </div>
      <div class="space-x-2">
        <div>
          <el-form
            ref="rulePaymentPasswordFormRef"
            label-position="top"
            :model="paymentPasswordFormData"
            status-icon
            :rules="paymentPasswordRules"
            label-width="150px"
            :validate-on-rule-change="false"
          >
            <el-form-item
              :label="$t('current_password')"
              prop="currentPassword"
            >
              <el-input
                v-model="paymentPasswordFormData.currentPassword"
                type="password"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('current_password') : ''"
              />
            </el-form-item>
            <el-form-item :label="$t('new_password')" prop="newPassword">
              <el-input
                v-model="paymentPasswordFormData.newPassword"
                type="password"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('new_password') : ''"
              />
            </el-form-item>
            <el-form-item
              :label="$t('confirm_password')"
              prop="confirmPassword"
            >
              <el-input
                v-model="paymentPasswordFormData.confirmPassword"
                type="password"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('confirm_password') : ''"
              />
            </el-form-item>
            <div :class="theme == 'bk8' ? 'flex justify-center' : ''">
              <el-form-item>
                <el-button
                  :disabled="isPaymentPassProccessing"
                  type="primary"
                  round
                  @click="changePaymentPassword(rulePaymentPasswordFormRef)"
                  >{{ $t("submit") }}</el-button
                >
              </el-form-item>
            </div>
          </el-form>
        </div>
        <div v-if="theme != 'bk8'">
          <b>
            <ul class="space-y-2 text-sm rounded">
              <h5 class="font-bold secondary">
                {{ $t("SBOKH_password_policy") }}
              </h5>
              <li>
                -
                {{
                  $t(
                    "payment_password_will_use_to_verify_your_identity_for_any_fund_related_operation_for_account_safety_purposes_please_enter_4_digits"
                  )
                }}
              </li>
              <li>
                - {{ $t("confirm_password_must_be_the_same_as_new_password") }}
              </li>
            </ul>
          </b>
        </div>
      </div>
    </div>
    <div v-if="isLoginNameEnabled" class="p-5 space-y-4">
      <h4>{{ $t("update_login_name") }}</h4>
      <div class="flex flex-col password-info">
        <div class="space-x-2 password-form">
          <el-form
            ref="ruleLoginNameFormRef"
            label-position="top"
            :model="loginNameFormData"
            :rules="loginNameRules"
            label-width="150px"
            :validate-on-rule-change="false"
          >
            <el-form-item :label="$t('new_login_name')" prop="newLoginName">
              <el-input
                v-model="loginNameFormData.newLoginName"
                autocomplete="off"
                :placeholder="theme == 'bk8' ? $t('new_login_name') : ''"
              />
            </el-form-item>
            <el-form-item>
              <el-button
                :disabled="isLoginNameProccessing"
                type="primary"
                round
                @click="changeLoginName(ruleLoginNameFormRef)"
                >{{ $t("submit") }}</el-button
              >
            </el-form-item>
          </el-form>
        </div>
        <div class="password-remark">
          <b>
            <ul class="space-y-2 text-sm rounded bk8-pwd">
              <h5
                :class="theme == 'bk8' ? 'font-[400]' : 'font-bold secondary'"
              >
                {{ $t("login_name_policy") }}
              </h5>
              <li>- {{ $t("login_name_policy_1") }}</li>
              <li>- {{ $t("login_name_policy_2") }}</li>
              <li>- {{ $t("login_name_policy_3") }}</li>
            </ul>
          </b>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { store } from "@/store";

export default defineComponent({
  setup() {
    const {
      ruleLoginPasswordFormRef,
      loginPasswordFormData,
      loginPasswordRules,
      changeLoginPassword,
      isLoginPassProccessing,
    } = useLoginPassword();
    const {
      rulePaymentPasswordFormRef,
      paymentPasswordFormData,
      isPaymentPassProccessing,
      paymentPasswordRules,
      changePaymentPassword,
      isPaymentPasswordSet,
      isCashPlayer,
    } = usePaymentPassword();
    const {
      ruleLoginNameFormRef,
      loginNameFormData,
      isLoginNameProcessing,
      loginNameRules,
      changeLoginName,
      isLoginNameEnabled,
    } = useLoginName();
    const { themeColor } = themePropertyHelper;
    const theme = themeColor.value.Text;
    const themeName = store.state.selectedThemeName;
    return {
      isLoginPassProccessing,
      isPaymentPassProccessing,
      isPaymentPasswordSet,
      ruleLoginPasswordFormRef,
      loginPasswordFormData,
      loginPasswordRules,
      changeLoginPassword,
      rulePaymentPasswordFormRef,
      paymentPasswordFormData,
      paymentPasswordRules,
      changePaymentPassword,
      isCashPlayer,
      ruleLoginNameFormRef,
      loginNameFormData,
      isLoginNameProcessing,
      loginNameRules,
      changeLoginName,
      isLoginNameEnabled,
      theme,
      themeName,
    };
  },
});
</script>

<style scoped lang="scss">
[theme-color="bk8"] {
  .el-button {
    width: 152px !important;
    height: 40px !important;
  }
  .bk8-policy {
    color: var(--text) !important;
  }
  .bk8-title {
    font-weight: 700;
    padding-left: 8px;
  }
  .bk8-custom {
    padding-bottom: 16px !important;
  }
  .bk8-custom-bottom {
    margin-top: 8px !important;
  }
  .password-info {
    margin-top: 8px !important;
    .password-remark {
      padding-bottom: 20px;
      .bk8-pwd {
        line-height: 16px;
        font-weight: 400;
      }
    }
  }
}
.space-y-4:last-child {
  padding-bottom: 100px;
}
</style>
